Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs	(revision 14897)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs	(revision 14897)
@@ -0,0 +1,68 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite {
+  using System.Linq;
+  using Common;
+  using Configuration;
+  using Core;
+  using Encodings.IntegerVectorEncoding;
+  using Expressions;
+  using HeuristicLab.BenchmarkSuite.Problems;
+  using Instances;
+  using Persistence.Default.CompositeSerializers.Storable;
+  using Stack;
+
+  [StorableClass]
+  [Creatable(CreatableAttribute.Categories.GeneticProgrammingProblems, Priority = 180)]
+  [Item("Push BenchmarkSuite Problem", "")]
+  public class PushBenchmarkSuiteProblem : PushProblem, IProblemInstanceConsumer<ProblemData> {
+    public PushBenchmarkSuiteProblem() : base(new PushBenchmarkSuiteEvaluator()) {
+      Parameters.Add(PushEvaluator.DataParameter);
+      Parameters.Add(PushEvaluator.DataBoundsParameter);
+    }
+
+    [StorableConstructor]
+    protected PushBenchmarkSuiteProblem(bool deserializing)
+      : base(deserializing) {
+    }
+
+    protected PushBenchmarkSuiteProblem(PushProblem original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PushBenchmarkSuiteProblem(this, cloner);
+    }
+
+    public new PushBenchmarkSuiteEvaluator PushEvaluator { get { return (PushBenchmarkSuiteEvaluator)base.PushEvaluator; } }
+
+    public void Load(ProblemData data) {
+      PushEvaluator.LoadData(data);
+
+      BestKnownQuality = data.BestResult;
+      MaxPointsInProgram = data.MaxSize;
+      MinPointsInProgram = data.MaxSize;
+      EvalPushLimit = data.EvalLimit;
+      ErcOptions = data.ErcOptions;
+
+      config.SetEnabledStacks((StackTypes)data.EnabledDataTypes);
+
+      // update enabled stack types
+      foreach (var stackType in ExpressionTable.StackTypeToNamesTable.Keys) {
+        var enable = config.EnabledExpressions.Intersect(ExpressionTable.StackTypeToNamesTable[stackType]).Any();
+        config.SetStack(stackType, enable);
+      }
+
+      Encoding.Bounds[0, 0] = 0;
+      Encoding.Bounds[0, 1] = config.EnabledExpressions.Count;
+      Encoding.Length = config.MaxPointsInProgram;
+    }
+
+    protected override PushSolution CreatePushSolution(
+      IntegerVector vector,
+      double bestQuality,
+      IRandom random,
+      IReadOnlyPushConfiguration config,
+      IPushEvaluator evaluator) {
+      return new PushBenchmarkSuiteSolution(vector, bestQuality, random, config, (PushBenchmarkSuiteEvaluator)PushEvaluator.Clone());
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteSolution.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteSolution.cs	(revision 14897)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteSolution.cs	(revision 14897)
@@ -0,0 +1,32 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite {
+  using Common;
+  using Configuration;
+  using Core;
+  using Encodings.IntegerVectorEncoding;
+  using Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
+  public class PushBenchmarkSuiteSolution : PushSolution {
+    public PushBenchmarkSuiteSolution(
+      IntegerVector integerVector,
+      double quality,
+      IRandom random,
+      IReadOnlyPushConfiguration config,
+      PushBenchmarkSuiteEvaluator evaluator,
+      bool simplify = false) : base(integerVector, quality, random, config, evaluator, simplify) {
+    }
+
+    public PushBenchmarkSuiteSolution(PushBenchmarkSuiteSolution origin, Cloner cloner) : base(origin, cloner) { }
+
+    [StorableConstructor]
+    public PushBenchmarkSuiteSolution(bool deserializing) : base(deserializing) { }
+
+    public override PushSolution Simplify() {
+      return new PushBenchmarkSuiteSolution(IntegerVector, Quality, Random, Config, (PushBenchmarkSuiteEvaluator)Evaluator, true);
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PushBenchmarkSuiteSolution(this, cloner);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/EvaluationResult.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/EvaluationResult.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/EvaluationResult.cs	(revision 14897)
@@ -1,20 +1,11 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-
-namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem
-{
-    public class EvaluationResult
-    {
-      public EvaluationResult(int exampleCount)
-      {
-        ExampleQualities = new double[exampleCount];
-      }
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem {
+  public class EvaluationResult {
+    public EvaluationResult(int exampleCount) {
+      ExampleQualities = new double[exampleCount];
+    }
 
 
-        public double TotalQuality { get; set; }
-        public double[] ExampleQualities { get; set; }
-    }
+    public double TotalQuality { get; set; }
+    public double[] ExampleQualities { get; set; }
+  }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IPushEvaluator.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IPushEvaluator.cs	(revision 14897)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IPushEvaluator.cs	(revision 14897)
@@ -0,0 +1,16 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem {
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+
+  public interface IPushEvaluator : IDeepCloneable {
+    EvaluationResult EvaluateTest(IReadOnlyPushConfiguration config, PushProgram program, IRandom random);
+    EvaluationResult EvaluateTest(IPushInterpreter interpreter, PushProgram program, IRandom random);
+    EvaluationResult EvaluateTest(PushInterpreterPool pool, PushProgram program, IRandom random);
+    EvaluationResult EvaluateTraining(IReadOnlyPushConfiguration config, PushProgram program, IRandom random);
+    EvaluationResult EvaluateTraining(IPushInterpreter interpreter, PushProgram program, IRandom random);
+    EvaluationResult EvaluateTraining(PushInterpreterPool pool, PushProgram program, IRandom random);
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IndividualMapper.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IndividualMapper.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/IndividualMapper.cs	(revision 14897)
@@ -43,7 +43,8 @@
 
     private static PushProgram ToPushProgram(this IntegerVector vector, IReadOnlyPushConfiguration config, IRandom random) {
-      var expressions = new Expression[vector.Length];
       var enabledExpressions = config.EnabledExpressions;
       var ercOptions = config.ErcOptions;
+      //var programLength = random.Next(config.MinPointsInProgram, config.MaxPointsInProgram + 1);
+      var expressions = new Expression[vector.Length];
 
       for (var i = 0; i < vector.Length; i++)
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 14897)
@@ -2,7 +2,6 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem {
-  using System.Collections.Generic;
   using System.Linq;
-  using BenchmarkSuite.Problems;
+
   using Common;
   using Configuration;
@@ -10,9 +9,8 @@
   using Data.Pool;
   using Encodings.IntegerVectorEncoding;
-  using Expressions;
   using HeuristicLab.Data;
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc;
-
-  using Instances;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite;
+
   using Interpreter;
   using Optimization;
@@ -20,14 +18,14 @@
   using Persistence.Default.CompositeSerializers.Storable;
   using Random;
-  using Stack;
 
   [StorableClass]
-  [Creatable(CreatableAttribute.Categories.GeneticProgrammingProblems, Priority = 180)]
-  [Item("Push Problem", "")]
-  public class PushProblem : SingleObjectiveBasicProblem<IntegerVectorEncoding>, IProblemInstanceConsumer<ProblemData> {
+  public abstract class PushProblem : SingleObjectiveBasicProblem<IntegerVectorEncoding> {
     [Storable]
-    private readonly PushConfiguration config;
-    private PushInterpreterPool pool;
-    private readonly ObjectPool<IRandom> randomPool = new ObjectPool<IRandom>(() => new MersenneTwister());
+    protected readonly PushConfiguration config;
+    protected PushInterpreterPool pool;
+    protected readonly ObjectPool<IRandom> randomPool = new ObjectPool<IRandom>(() => new MersenneTwister());
+
+    [Storable]
+    protected readonly IPushEvaluator PushEvaluator;
 
     public const string CaseQualitiesScopeParameterName = "CaseQualities";
@@ -35,6 +33,7 @@
     private const string TestQualityResultName = "Test Quality";
 
-    public PushProblem() {
+    protected PushProblem(PushBenchmarkSuiteEvaluator evaluator) {
       config = new PushConfiguration();
+      PushEvaluator = evaluator;
 
       InitData();
@@ -44,11 +43,12 @@
 
     [StorableConstructor]
-    public PushProblem(bool deserializing)
+    protected PushProblem(bool deserializing)
       : base(deserializing) {
     }
 
-    public PushProblem(PushProblem original, Cloner cloner)
+    protected PushProblem(PushProblem original, Cloner cloner)
       : base(original, cloner) {
       config = cloner.Clone(original.config);
+      PushEvaluator = cloner.Clone(original.PushEvaluator);
 
       InitData();
@@ -78,13 +78,12 @@
     #region Parameters
 
-    private const string DataBoundsParameterName = "DataBounds";
-    private const string DataParameterName = "Data";
-    private const string DataParameterDescription = "Program Synthesis";
     private const string InstructionsParameterName = "Instructions";
     private const string InstructionsParameterDescription = "Enables/Disables Instructions";
     private const string EvalPushLimitParameterName = "EvalPushLimit";
     private const string EvalPushLimitParameterDescription = "This is the maximum allowed number of \"executions\" in a single top-level call to the interpreter. The execution of a single Push instruction counts as one execution, as does the processing of a single literal, as does the descent into one layer of parentheses (that is, the processing of the \"(\" counts as one execution).";
+    private const string MinPointsInProgramParameterName = "MinProgramLength";
+    private const string MinProgramLengthParameterDescription = "This is the minimum size of an item on the CODE/EXEC stack, expressed as a number of points. A point is an instruction, a literal, or a pair of parentheses.";
     private const string MaxPointsInProgramParameterName = "MaxProgramLength";
-    private const string MaxProgramLengthParameterDescription = "This is the maximum size of an item on the CODE stack, expressed as a number of points. A point is an instruction, a literal, or a pair of parentheses.";
+    private const string MaxProgramLengthParameterDescription = "This is the maximum size of an item on the CODE/EXEC stack, expressed as a number of points. A point is an instruction, a literal, or a pair of parentheses.";
     private const string TopLevelPushCodeParameterName = "TopLevelPushCode";
     private const string TopLevelPushCodeParameterDescription = "When TRUE (which is the default), code passed to the top level of the interpreter will be pushed onto the CODE stack prior to execution.";
@@ -98,6 +97,4 @@
 
     private void InitParameters() {
-      Parameters.Add(new FixedValueParameter<DataBounds>(DataBoundsParameterName));
-
       Parameters.Add(new ValueParameter<IEnabledExpressionsConfiguration>(
         InstructionsParameterName,
@@ -105,8 +102,4 @@
         config));
 
-      Parameters.Add(new ValueParameter<ProblemData>(
-        DataParameterName,
-        DataParameterDescription));
-
       Parameters.Add(new ValueParameter<ErcOptions>(ErcOptionsParameterName, config.ErcOptions));
 
@@ -117,8 +110,13 @@
 
       Parameters.Add(new FixedValueParameter<IntValue>(
+        MinPointsInProgramParameterName,
+        MinProgramLengthParameterDescription,
+        new IntValue(config.MinPointsInProgram)) { Hidden = true });
+
+      Parameters.Add(new FixedValueParameter<IntValue>(
         MaxPointsInProgramParameterName,
         MaxProgramLengthParameterDescription,
         new IntValue(config.MaxPointsInProgram)));
-      Encoding.LengthParameter = Parameters[MaxPointsInProgramParameterName] as IFixedValueParameter<IntValue>;
+      Encoding.LengthParameter = MaxPointsInProgramParameter as IFixedValueParameter<IntValue>;
 
       Parameters.Add(new FixedValueParameter<BoolValue>(
@@ -153,16 +151,4 @@
     }
 
-    public IValueParameter<DataBounds> DataBoundsParameter
-    {
-      get { return (IValueParameter<DataBounds>)Parameters[DataBoundsParameterName]; }
-    }
-
-    public DataBounds DataBounds
-    {
-      get { return DataBoundsParameter.Value; }
-      set { DataBoundsParameter.Value = value; }
-    }
-
-
     public IValueParameter<IEnabledExpressionsConfiguration> InstructionsParameter
     {
@@ -174,15 +160,4 @@
       get { return InstructionsParameter.Value; }
       set { InstructionsParameter.Value = value; }
-    }
-
-    public IValueParameter<ProblemData> DataParameter
-    {
-      get { return (IValueParameter<ProblemData>)Parameters[DataParameterName]; }
-    }
-
-    public ProblemData Data
-    {
-      get { return DataParameter.Value; }
-      set { DataParameter.Value = value; }
     }
 
@@ -267,4 +242,26 @@
 
     /// <summary>
+    ///     This is the minimum size of an item on the CODE stack, expressed as a number of points.
+    ///     A point is an instruction, a literal, or a pair of parentheses. Any instruction that would cause this limit to be
+    ///     exceeded
+    ///     should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the
+    ///     instruction.
+    /// </summary>
+    public IValueParameter<IntValue> MinPointsInProgramParameter
+    {
+      get { return (IValueParameter<IntValue>)this.Parameters[MinPointsInProgramParameterName]; }
+    }
+
+    public int MinPointsInProgram
+    {
+      get { return config.MaxPointsInProgram; }
+      set
+      {
+        MinPointsInProgramParameter.Value.Value = value;
+        config.MinPointsInProgram = value;
+      }
+    }
+
+    /// <summary>
     ///     The maximum number of points in an expression produced by the CODE.RAND instruction.
     /// </summary>
@@ -338,8 +335,4 @@
 
     public override bool Maximization { get { return false; } }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new PushProblem(this, cloner);
-    }
 
     public override void Analyze(Individual[] individuals, double[] qualities, ResultCollection results, IRandom random) {
@@ -357,15 +350,20 @@
     private void AnalyzeBestTestSolution(IntegerVector bestIndividual, ResultCollection results, IRandom random) {
       var program = bestIndividual.ToPushProgram(config, randomPool);
-      var trainingResult = PushEvaluator.Evaluate(program, pool, random, Data, DataBounds.TestRange.Start, DataBounds.TestRange.End);
+      var testResult = PushEvaluator.EvaluateTest(pool, program, random);
 
       if (!results.ContainsKey(TestQualityResultName)) {
-        results.Add(new Result(TestQualityResultName, new DoubleValue(trainingResult.TotalQuality)));
+        results.Add(new Result(TestQualityResultName, new DoubleValue(testResult.TotalQuality)));
       } else {
-        ((DoubleValue)results[TestQualityResultName].Value).Value = trainingResult.TotalQuality;
+        ((DoubleValue)results[TestQualityResultName].Value).Value = testResult.TotalQuality;
       }
     }
 
     private bool AnalyzeBestTrainingSolution(IntegerVector bestIndividual, double bestQuality, ResultCollection results, IRandom random) {
-      var solution = new PushSolution(bestIndividual, bestQuality, Data, random, config, DataBounds.TrainingRange.Start, DataBounds.TrainingRange.End);
+      var solution = CreatePushSolution(
+        bestIndividual,
+        bestQuality,
+        random,
+        config,
+        PushEvaluator);
 
       if (!results.ContainsKey(BestTrainingSolutionResultName)) {
@@ -385,42 +383,18 @@
     }
 
+    protected abstract PushSolution CreatePushSolution(
+      IntegerVector vector,
+      double bestQuality,
+      IRandom random,
+      IReadOnlyPushConfiguration config,
+      IPushEvaluator evaluator);
+
     public override double Evaluate(Individual individual, IRandom random) {
       var program = individual.ToPushProgram(config, randomPool);
-      var result = PushEvaluator.Evaluate(
-        program,
-        pool,
-        random,
-        Data,
-        DataBounds.TrainingRange.Start,
-        DataBounds.TrainingRange.End);
-
-      individual.SetScopeValue(CaseQualitiesScopeParameterName, new DoubleArray(result.ExampleQualities));
+      var result = PushEvaluator.EvaluateTraining(pool, program, random);
+
+      individual[CaseQualitiesScopeParameterName] = new DoubleArray(result.ExampleQualities);
 
       return result.TotalQuality;
-    }
-
-    public void Load(ProblemData data) {
-      Data = data;
-      BestKnownQuality = data.BestResult;
-      MaxPointsInProgram = data.MaxSize;
-      EvalPushLimit = data.EvalLimit;
-      ErcOptions = data.ErcOptions;
-
-      config.EnabledExpressions = (IList<string>)ExpressionTable.GetExpressionsByStackTypes((StackTypes)data.EnabledDataTypes);
-
-      // update enabled stack types
-      foreach (var stackType in ExpressionTable.StackTypeToNamesTable.Keys) {
-        var enable = config.EnabledExpressions.Intersect(ExpressionTable.StackTypeToNamesTable[stackType]).Any();
-        config.SetStack(stackType, enable);
-      }
-
-      Encoding.Bounds[0, 0] = 0;
-      Encoding.Bounds[0, 1] = config.EnabledExpressions.Count;
-      Encoding.Length = config.MaxPointsInProgram;
-
-      DataBounds.TrainingRange.Start = 0;
-      DataBounds.TrainingRange.End = Data.TrainingCount;
-      DataBounds.TestRange.Start = Data.TrainingCount;
-      DataBounds.TestRange.End = Data.TrainingCount + Data.TestCount;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs	(revision 14897)
@@ -1,9 +1,9 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem {
-  using HeuristicLab.BenchmarkSuite.Problems;
-  using HeuristicLab.Common;
-  using HeuristicLab.Core;
-  using HeuristicLab.Encodings.IntegerVectorEncoding;
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
+  using Common;
+  using Configuration;
+  using Core;
+  using Encodings.IntegerVectorEncoding;
+  using Expressions;
+  using Persistence.Default.CompositeSerializers.Storable;
 
   [StorableClass]
@@ -14,41 +14,40 @@
     public readonly IntegerVector IntegerVector;
     [Storable]
-    public readonly ProblemData Data;
-    [Storable]
     public readonly IRandom Random;
     [Storable]
     public readonly IReadOnlyPushConfiguration Config;
+
     [Storable]
-    public readonly int DataStart;
-    [Storable]
-    public readonly int DataEnd;
-    [Storable]
-    public readonly bool Simplify;
+    public readonly IPushEvaluator Evaluator;
 
-    public PushSolution(IntegerVector integerVector, double quality, ProblemData data, IRandom random, IReadOnlyPushConfiguration config, int dataStart, int dataEnd, bool simplify = false)
+    public readonly PushProgram Program;
+
+    public PushSolution(IntegerVector integerVector, double quality, IRandom random, IReadOnlyPushConfiguration config, IPushEvaluator evaluator, bool simplify = false)
       : base("Solution", "A push solution.") {
       IntegerVector = integerVector;
       Quality = quality;
-      Data = data;
       Random = random;
       Config = config;
-      DataStart = dataStart;
-      DataEnd = dataEnd;
-      Simplify = simplify;
+      Evaluator = evaluator;
+
+      Program = IntegerVector.ToPushProgram(config);
+
+      if (simplify)
+        Program = Simplifier.Simplifier.Simplify(Program, p => Evaluator.EvaluateTraining(config, p, random).TotalQuality);
     }
 
     public PushSolution(PushSolution origin, Cloner cloner) : base(origin, cloner) {
+      Quality = origin.Quality;
       IntegerVector = cloner.Clone(origin.IntegerVector);
-      Quality = origin.Quality;
-      Data = cloner.Clone(origin.Data);
       Random = cloner.Clone(origin.Random);
       Config = cloner.Clone(origin.Config);
-      DataStart = origin.DataStart;
-      DataEnd = origin.DataEnd;
-      Simplify = origin.Simplify;
+    }
+
+    public virtual PushSolution Simplify() {
+      return new PushSolution(IntegerVector, Quality, Random, Config, Evaluator, true);
     }
 
     [StorableConstructor]
-    private PushSolution(bool deserializing) : base(deserializing) { }
+    protected PushSolution(bool deserializing) : base(deserializing) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/StackTypes.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/StackTypes.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/StackTypes.cs	(revision 14897)
@@ -5,5 +5,5 @@
   [Flags]
   public enum StackTypes : ushort {
-    None = 0x00, // Required to specify expression dependencies
+    None = 0x01, // Required to specify expression dependencies
     Integer = 0x02,
     Float = 0x04,
@@ -14,9 +14,9 @@
     Code = 0x80,
     Exec = 0x100,
-    Return = 0x200,
+    Print = 0x200,
     IntegerVector = 0x400,
     FloatVector = 0x800,
     StringVector = 0x1000,
-    BooleanVector = 0x2000
+    BooleanVector = 0x2000,
   }
 }
